/*
 * NUnit test for NorwegianStemmer
 * 
 * Author: Bjrn Harald Olsen 2006
 */
using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using NUnit.Framework;

namespace NorwegianAnalyzer.NUnit
{
    [TestFixture]
    public class NorwegianStemmerTest
    {
        private NorwegianStemmer stemmer;
        private string vocFile;

        [SetUp]
        protected void SetUp()
        {            
            stemmer = new NorwegianStemmer();
            vocFile = "C:\\Diplom\\Impl\\NorwegianAnalyzer\\resources\\diffs.txt";
            // Needs to have two columns; the first unstemmed, second the stemmed version of word
        }

        [Test]
        public void StemSomething()
        {
            using (StreamReader sr = new StreamReader(vocFile, System.Text.Encoding.GetEncoding("ISO8859-1")))
            {

                while (sr.Peek() >= 0)
                {
                    string[] comp = sr.ReadLine().Split(' ');
                    //Console.WriteLine(comp[0]);
                    string original = comp[0];
                    string stem = comp[comp.Length - 1];
                    Assert.AreEqual(stem, stemmer.Stem(original));
                }
            }
        }
    }
}
