/*
 * Author Bjrn Harald Olsen 2006
 * 
 */
using System;
using System.IO;
using System.Xml;
using System.Text;
using System.Text.RegularExpressions;

namespace TrelsEval
{
	public class TrelsXmlReader
	{
		public static RelevanceSet Parse(FileInfo fi)
		{
			try
			{
				RelevanceSet tSet;
				XmlTextReader reader = new XmlTextReader(fi.FullName);				
				
				// Read the Start Element				
				reader.ReadStartElement("Trel");
                string query = reader.ReadElementString("query");
                if (query == "" || query == " ") return null;
				tSet = new RelevanceSet(query);
				
				while (reader.Read())
				{					
					if (reader.NodeType == XmlNodeType.Element && 
						reader.Name == "offTopics")
					{
						reader.ReadStartElement("offTopics");
						
						while(reader.Read())
						{
							if (reader.NodeType == XmlNodeType.Element && 
								reader.Name == "offTopic")
							{
								tSet.addOffTopic(reader.ReadElementString("offTopic"));										
							}
							else							
								break;							
						}
						reader.ReadEndElement();											
					}	
					else if(reader.NodeType == XmlNodeType.Element && 
						reader.Name == "onTopics")
					{
						reader.ReadStartElement("onTopics");
						
						while(reader.Read())
						{					
							if (reader.NodeType == XmlNodeType.Element && 
								reader.Name == "onTopic")
							{
								tSet.addOnTopic(reader.ReadElementString("onTopic"));						
							}
							else 
								break;
						}
					}
					else 
						break;
				}					
				reader.ReadEndElement();
				reader.Close();

				return tSet;
			}
			catch (XmlException xmle)
			{				
				string er=xmle.ToString();
				Match res = Regex.Match(er,"Line [0-9]+, position [0-9]+");
                string info = er.Substring(res.Index, res.Length);
                Console.WriteLine("Skipping " + fi.Name + ". Wrong syntax at " + info);
			}
			catch (Exception e)
			{
				Console.WriteLine("Xmlreader: "+e.ToString());
			}
			return null;
		}		
	}
}
